/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/


dojo.provide('javascript.widgets.PasswordVerify');

dojo.require("dijit.form.TextBox");
dojo.require("javascript.widgets.GenericDialog");
dojo.requireLocalization("javascript.widgets", "xsa_messages");

dojo.declare('javascript.widgets.PasswordVerify', [dijit._Widget, dijit._Templated], {   

	templatePath: dojo.moduleUrl("javascript","widgets/templates/PasswordVerifyTemplate.html"),
	widgetsInTemplate: true,
	       
        fieldID: "",
        uri: "",
        errorCallback: "",
        loadCallback: "",
	newLabel: "",
	verifyLabel: "",
        showHide: true,
	         
        xsa_messages : null,

	constructor: function(args) {
		this.inherited(arguments);
		if(args.fieldID) {
			this.field = args.fieldID;
		}
		if(args.uri) {
			this.uri = args.uri;
		}
		if(args.errorCallback) {
			this.errorCallback = args.errorCallback;
		}
		if(args.loadCallback) {
			this.loadCallback = args.loadCallback;
		}
		if(args.showHide!=undefined) {
			this.showHide = args.showHide;
		}
		this.xsa_messages = dojo.i18n.getLocalization("javascript.widgets", "xsa_messages");
		this.edit = this.xsa_messages.edit;
		this.save = this.xsa_messages.save;
		this.newLabel = args.newLabel ? args.newLabel : this.xsa_messages.newLabel;
		this.verifyLabel = args.verifyLabel ? args.verifyLabel : this.xsa_messages.verifyLabel;
	},
	
	postCreate: function() {
		this.inherited(arguments);
		if(!this.showHide) {
			this._toggleEditPassword();
			dojo.style(this._showPasswordDiv, "display", "none");
		}
        },

	_getDisabledAttr: function(){
		return this._disabled;
	},
								
	_setDisabledAttr: function(disabled){
		if(this._disabled == disabled){ return; }
		this.saveButton.disabled = disabled;
		this._newPasswordInput.set("disabled", disabled);
		this._verifyPasswordInput.set("disabled", disabled);
	},
	        
        _toggleEditPassword: function() {
        	var _display = dojo.style(this._editPasswordDiv, 'display');
        	
        	if (_display == 'none'){
        		dojo.style(this._editPasswordDiv, 'display', '');
        		dojo.style(this._editPasswordDiv, 'visibility', 'visible');
        	        this._editPasswordLink.innerHTML = "<span style='color:black'>[</span>"+this.xsa_messages.hide+"<span style='color:black'>]</span>";
        	} else{
        	        dojo.style(this._editPasswordDiv, 'display', 'none');
        	        dojo.style(this._editPasswordDiv, 'visibility', 'hidden');
        		this._editPasswordLink.innerHTML = "<span style='color:black'>[</span>"+this.xsa_messages.edit+"<span style='color:black'>]</span>";
        	}
        	Bedrock.hide(this._verificationSuccessImg);
        },
        
	_verifyPassword: function() {
		var first = this._newPasswordInput.get("value");
		var second = this._verifyPasswordInput.get("value");
		var icon = this._verificationSuccessImg;
		if (second.length == 0){
			Bedrock.hide(icon);
			return;
		}
		var success = first == second;
		
		icon.src = success ? '/images/success-icon.gif' : '/images/error-icon.gif';
		icon.alt = icon.title = (success ? this.xsa_messages.match : this.xsa_messages.doNotMatch);
		        
		Bedrock.show(icon);
		
		return success;
	},
	
	_submitPassword: function() {
		var json = {
				'value': this._newPasswordInput.get("value"),
				'verification': this._verifyPasswordInput.get("value")
		};
		json[this.field]=this._newPasswordInput.get("value");
		var jsonString = dojo.toJson(json);
		var request = {
			url:  this.uri,
			postData: jsonString,
			headers: {
			    'Accept': 'application/json'
			},
			contentType: "application/json" ,
			load: dojo.hitch(this, function (response, ioArgs){
				this.showPasswordSuccess(true);
				if (this.loadCallback) this.loadCallback(response);
			}),
			error: dojo.hitch(this, function(data, ioArgs){
				if (this.errorCallback) this.errorCallback(ioArgs.xhr.response);
			})
		}
		var deferred = dojo.rawXhrPut(request);
	},
	
	showPasswordSuccess: function() {
	        //TODO: show this success/fail at the top of the page
	                	
		Bedrock.hide(this._verificationSuccessImg);
	},
		
	destroy: function(){
		this.inherited(arguments);
	}
});
