/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("javascript.widgets.XSASingleMessage");

dojo.require("idx.oneui.messaging.SingleMessage");

dojo.declare("javascript.widgets.XSASingleMessage", [idx.oneui.messaging.SingleMessage],{
	
    /**
	 * Whether to show the title link.  This is a destructive setting. Once showLink has been set to false, it cannot be set back to true
	 * @type Boolean
	 * @default true
	 */
	showLink: true,
	
	postCreate: function(){
		this.inherited(arguments);
		
		//Get rid of the More Details link
		dojo.destroy(this.viewDetailsNode);
	},	
	
	postMixInProperties: function(){
        var origType = this.type.toLowerCase();
        this.inherited(arguments);
        if(dojo.isIE<8) this.type = origType;
	},
	
	_setShowLinkAttr: function(/*Boolean*/ show){
		this._set("showLink", show);
		dojo.toggleClass(this.focusNode, "idxMessageContentNoLink", !this.showLink);
		dojo.toggleClass(this.focusNode, "idxMessageContent", this.showLink);
		dojo.toggleClass(this.titleNode, "noLink", !this.showLink);
		dojo.toggleClass(this.iconNode, "noLink", !this.showLink);
		dojo.removeClass(this.infoNode, "idxMessageRightAligned");
		if(!show) {
			dojo.removeAttr(this.focusNode, "title");
			this._onClick = function(e){/*no-op*/};
			this.collapsed=false; //force it to wrap the title node
		}
	},
	
	_setCollapsedAttr: function(value){
		this.inherited(arguments);
		if(!this.showLink) dojo.removeAttr(this.focusNode, "title");			
	},
	
	_resizeTitle: function(){
		if(!this._created){
			return;
		}
		if(!this.showLink) {
			//hack this to look right without the details showing up
			dojo.style(this.bodyNode, "height", "0px");	                                                                                                                                                                                                                                                                                                                                                                        
			dojo.style(this.bodyNode, "visibility", "hidden");
			
			dojo.forEach(dojo.query("div.idxMessageSplitter"), function(div){ dojo.style(div, "height", "0px"); dojo.style(div, "border", "0px");});	                                                                                                                                                                                                                                                                                                                                                                        
			dojo.forEach(dojo.query("div.idxMessageRefresh"), function(div){ dojo.style(div, "margin", "0px"); });	 
			dojo.toggleClass(this.fakeTitleNode, "noLink", !this.showLink);                                                                                                                                                                                                                                                                                                                                                                       
			dojo.toggleClass(this.fakeTitleNode, "idxMessageContentNoLink", !this.showLink);
		
			//For IE7, dijitInline does not play nice with this widget on IE7.
			if(dojo.isIE<8) {
				dojo.removeClass(this.focusNode, "dijitInline");
				dojo.removeClass(this.iconNode, "dijitInline");
				dojo.removeClass(this.infoNode, "dijitInline");
				dojo.removeClass(this.titleNode, "dijitInline");
				dojo.removeClass(this.idNode, "dijitInline");
			}
				
			//HACK: do not call inherited method for IE7 because it causes errors on the page. wrapping will have to just be how it is for IE7.
			if(dojo.isIE>7) {
				//HACK: The parent resizeTitle only does a good job if the message truely needs to wrap, otherwise it looks better if we don't call it all
				if((dojo.marginBox(this.iconNode).w+dojo.marginBox(this.fakeFocusNode).w+dojo.marginBox(this.infoNode).w) > dojo.contentBox(this.domNode).w) {
					this.inherited(arguments);
				}
			}
		} else {
			 if(this.collapsed){
				if((dojo.marginBox(this.iconNode).w+dojo.marginBox(this.fakeFocusNode).w+dojo.marginBox(this.infoNode).w) > dojo.contentBox(this.domNode).w){
					this.inherited(arguments);
				} else {
					dojo.attr(this.titleNode, {"innerHTML": '<div class="messageTitles">' + this.title + '&nbsp&nbsp</div>'});
				}
			}else{
				this.inherited(arguments);
			}
		}
	},
	
	_onClick: function(e){
		this.inherited(arguments);
		this._resizeBorderContainer();
	},
	
	_onClose: function(e){
		this.inherited(arguments);
		this._resizeBorderContainer();
	},
	
	_resizeBorderContainer: function(){
		//Resize border container
		var bc = dijit.byId("message_center_border_container");
		if(bc) bc.resize();
	},
	
	destroy: function(){
		this.inherited(arguments);
		this._resizeBorderContainer();
	}
});